"use client";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { useState } from "react";
import classNames from "classnames";
var getUpArrow = function (addlClasses) { return (<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" className={classNames(__spreadArray(["bi", "bi-arrow-up"], (addlClasses || []), true))} viewBox="0 0 16 16">
    <path fillRule="evenodd" d="M8 15a.5.5 0 0 0 .5-.5V2.707l3.146 3.147a.5.5 0 0 0 .708-.708l-4-4a.5.5 0 0 0-.708 0l-4 4a.5.5 0 1 0 .708.708L7.5 2.707V14.5a.5.5 0 0 0 .5.5"/>
  </svg>); };
var downArrow = (<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" className="bi bi-arrow-down" viewBox="0 0 16 16">
    <path fillRule="evenodd" d="M8 1a.5.5 0 0 1 .5.5v11.793l3.146-3.147a.5.5 0 0 1 .708.708l-4 4a.5.5 0 0 1-.708 0l-4-4a.5.5 0 0 1 .708-.708L7.5 13.293V1.5A.5.5 0 0 1 8 1"/>
  </svg>);
// Temporary solution to prevent column widths from changing when hovering over
// columns with a mouse.
// More ideal permanent solution would be to fix column widths based on preset
// values.
var placeholder = (<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" className="bi bi-arrow-down" viewBox="0 0 16 16"></svg>);
var ColHeaderCell = function (_a) {
    var label = _a.label, sortModel = _a.sortModel;
    var _b = useState(false), isHovering = _b[0], setIsHovering = _b[1];
    var handleMouseOver = function () {
        return setIsHovering(true);
    };
    var handleMouseOut = function () {
        return setIsHovering(false);
    };
    var handleClick = function () {
        if (!sortModel) {
            return;
        }
        switch (sortModel.sortOrder) {
            case null: {
                sortModel.setSortOrder("asc");
                return;
            }
            case "asc": {
                sortModel.setSortOrder("desc");
                return;
            }
            case "desc": {
                sortModel.setSortOrder(null);
            }
        }
    };
    var getSortSymbol = function () {
        if (!sortModel) {
            return null;
        }
        switch (sortModel.sortOrder) {
            case null: {
                if (isHovering) {
                    return getUpArrow(["text-body-secondary"]);
                }
                return placeholder;
            }
            case "asc": {
                return getUpArrow();
            }
            case "desc": {
                return downArrow;
            }
        }
    };
    return (<th onClick={sortModel && handleClick} onMouseOver={handleMouseOver} onMouseOut={handleMouseOut} aria-description="Column header that can be clicked to change the sorting mode" style={{ cursor: "pointer " }}>
      {label}
      {getSortSymbol()}
    </th>);
};
export default ColHeaderCell;
